
    { Multi-Format Programm fuer IBM-PC/XT, Version 22.01.87  B.E. }

         { 64K Stack & Heap genuegen; wenn beim compilieren
                 max. 1000 par. Stack verlangt werden,
             muss COMMAND nicht immer nachgeladen werden! }

program MultiFormat;

{$R+,C-}

const
      Version : String [30] = 'MForm v1.10, April 2023';

      DataSeg : integer = 0;
      Fmax    = 35;
      Format  : array [1..Fmax] of
                  record
                    name : string [20];
                    BS   : 0..3;    { Sektorgroesse: 0=128 1=256 2=512 3=1024}
                    BLS  : 1..8;    { Blockgroesse in KBytes                 }
                    SPT  : Byte;    { 128-Byte-Sektoren pro Spur             }
                    DSM  : integer; { Hoechste Blocknummer                   }
                    DRM  : Byte;    { Directoryeintraege - 1                 }
                    OFF  : 0..8;    { Offest fuer erste Spur                 }
                    Sec1 : 0..1;    { Erster Sektor                          }
                    Letz : Byte;    { Letzter Sektor                         }
                    SXT  : Byte;    { Art der Sektor-Uebersetzung            }
                    TXT  : 0..5;    { Art der Spur-Uebersetzung              }
                    TRK  : Byte;    { Spuren -1                              }
                    GAP  : Byte     { GAP bei Format                         }
                  end

                =((name : 'ADPS';
                   BS   :   2; BLS  :   1; SPT :  32;
                   DSM  : 151; DRM  :  63; OFF :   2;
                   Sec1 :   1; Letz :   8; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  80),

                  (name : 'AK 1024x5, 800k DD';
                   BS   :   3; BLS  :   4; SPT :  40;
                   DSM  : 196; DRM  : 127; OFF :   2;
                   Sec1 :   1; Letz :   5; SXT :   0;
                   TXT  :   1; TRK  :  79; GAP :  53),

                  (name : 'AK 1024x9, 1.4Mb HD';
                   BS   :   3; BLS  :   4; SPT :  72;
                   DSM  : 354; DRM  : 255; OFF :   2;
                   Sec1 :   1; Letz :   9; SXT :   0;
                   TXT  :   1; TRK  :  79; GAP :  53),

                  (name : 'Alphatronic PC';
                   BS   :   1; BLS  :   2; SPT :  64;
                   DSM  : 151; DRM  :  63; OFF :   2;
                   Sec1 :   1; Letz :  16; SXT :   1;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'BASF-7120';
                   BS   :   3; BLS  :   2; SPT :  40;
                   DSM  :  79; DRM  :  63; OFF :   3;
                   Sec1 :   1; Letz :   5; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  80),

                  (name : 'Basis 208';
                   BS   :   2; BLS  :   2; SPT :  80;
                   DSM  : 194; DRM  : 127; OFF :   1;
                   Sec1 :   1; Letz :  10; SXT : $83;
                   TXT  :   0; TRK  :  39; GAP :  13),

                  (name : 'Bondwell 12';
                   BS   :   1; BLS  :   2; SPT :  36;
                   DSM  :  84; DRM  : 127; OFF :   2;
                   Sec1 :   0; Letz :  17; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  12),

                  (name : 'Bondwell 14';
                   BS   :   1; BLS  :   2; SPT :  36;
                   DSM  : 174; DRM  : 127; OFF :   2;
                   Sec1 :   0; Letz :  17; SXT :   0;
                   TXT  :   2; TRK  :  39; GAP :  12),

                  (name : 'Casio FP-1100';
                   BS   :   1; BLS  :   2; SPT :  64;
                   DSM  : 151; DRM  : 127; OFF :   2;
                   Sec1 :   1; Letz :  16; SXT :   1;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'Corona CP/M-86';
                   BS   :   2; BLS  :   2; SPT :  32;
                   DSM  : 157; DRM  :  63; OFF :   1;
                   Sec1 :   1; Letz :   8; SXT :   0;
                   TXT  :   3; TRK  :  39; GAP :  80),

                  (name : 'Cromemco CDOS SS';
                   BS   :   2; BLS  :   1; SPT :  40;
                   DSM  : 189; DRM  :  63; OFF :   2;
                   Sec1 :   1; Letz :  10; SXT : $C4;
                   TXT  :   0; TRK  :  39; GAP :  13),

                  (name : 'ECMA-70';
                   BS   :   1; BLS  :   1; SPT :  32;
                   DSM  : 143; DRM  :  63; OFF :   4;
                   Sec1 :   1; Letz :  16; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'Epson QX-10';
                   BS   :   1; BLS  :   2; SPT :  64;
                   DSM  : 143; DRM  :  63; OFF :   4;
                   Sec1 :   1; Letz :  16; SXT :   1;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'Eurocom II Fmt. 2';
                   BS   :   1; BLS  :   1; SPT :  32;
                   DSM  : 147; DRM  :  63; OFF :   3;
                   Sec1 :   1; Letz :  16; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'Eurocom II Fmt. 4';
                   BS   :   1; BLS  :   2; SPT :  64;
                   DSM  : 147; DRM  :  63; OFF :   3;
                   Sec1 :   1; Letz :  32; SXT :   2;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'Honeywell';
                   BS   :   1; BLS  :   2; SPT :  32;
                   DSM  : 153; DRM  : 127; OFF :   3;
                   Sec1 :   1; Letz :  16; SXT :   0;
                   TXT  :   1; TRK  :  39; GAP :  50),

                  (name : 'IBM CP/M-86 DS';
                   BS   :   2; BLS  :   2; SPT :  32;
                   DSM  : 157; DRM  :  63; OFF :   1;
                   Sec1 :   1; Letz :   8; SXT :   0;
                   TXT  :   3; TRK  :  39; GAP :  80),

                  (name : 'IBM CP/M-86 SS';
                   BS   :   2; BLS  :   1; SPT :  32;
                   DSM  : 155; DRM  :  63; OFF :   1;
                   Sec1 :   1; Letz :   8; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  80),

                  (name : 'ITT 3030, 35 Tr.';
                   BS   :   1; BLS  :   1; SPT :  32;
                   DSM  : 255; DRM  :  63; OFF :   4;
                   Sec1 :   1; Letz :  16; SXT :   0;
                   TXT  :   4; TRK  :  35; GAP :  50),

                  (name : 'Kaypro II';
                   BS   :   2; BLS  :   1; SPT :  40;
                   DSM  : 194; DRM  :  63; OFF :   1;
                   Sec1 :   0; Letz :   9; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  15),

                  (name : 'Kaypro 4/10';
                   BS   :   2; BLS  :   2; SPT :  40;
                   DSM  : 194; DRM  :  63; OFF :   1;
                   Sec1 :   0; Letz :  19; SXT :   0;
                   TXT  :   5; TRK  :  39; GAP :  15),

                  (name : 'Kontron, 77 Tr.';
                   BS   :   1; BLS  :   2; SPT :  32;
                   DSM  : 300; DRM  : 128; OFF :   4;
                   Sec1 :   1; Letz :  16; SXT : 131;
                   TXT  :   0; TRK  :  76; GAP :  50),

                  (name : 'MC NKC/NDR, 80 Tr.';
                   BS   :   3; BLS  :   2; SPT :  40;
                   DSM  : 389; DRM  : 255; OFF :   4;
                   Sec1 :   1; Letz :   5; SXT :   0;
                   TXT  :   1; TRK  :  79; GAP :  80),

                  (name : 'MC-CP/M+ #7';
                   BS   :   1; BLS  :   1; SPT :  32;
                   DSM  : 143; DRM  :  63; OFF :   4;
                   Sec1 :   1; Letz :  16; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'NCR';
                   BS   :   2; BLS  :   2; SPT :  32;
                   DSM  : 153; DRM  :  63; OFF :   3;
                   Sec1 :   1; Letz :   8; SXT : 129;
                   TXT  :   2; TRK  :  39; GAP :  80),

                  (name : 'NEC-8000';
                   BS   :   1; BLS  :   2; SPT :  64;
                   DSM  : 155; DRM  :  63; OFF :   1;
                   Sec1 :   1; Letz :  16; SXT :   1;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'NEC-8800';
                   BS   :   1; BLS  :   2; SPT :  64;
                   DSM  : 151; DRM  : 127; OFF :   2;
                   Sec1 :   1; Letz :  16; SXT :   1;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'NEC PC 8001';
                   BS   :   1; BLS  :   1; SPT :  32;
                   DSM  : 151; DRM  :  63; OFF :   2;
                   Sec1 :   1; Letz :  16; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  50),

                  (name : 'Osborne SS';
                   BS   :   3; BLS  :   1; SPT :  40;
                   DSM  : 184; DRM  :  63; OFF :   3;
                   Sec1 :   1; Letz :   5; SXT :   0;
                   TXT  :   0; TRK  :  39; GAP :  80),

                  (name : 'Philips P2000-12';
                   BS   :   1; BLS  :   4; SPT :  32;
                   DSM  : 157; DRM  : 127; OFF :   2;
                   Sec1 :   1; Letz :  16; SXT : 194;
                   TXT  :   1; TRK  :  79; GAP :  50),

                  (name : 'Prof #2 40 Track';
                   BS   :   2; BLS  :   2; SPT :  80;
                   DSM  : 184; DRM  : 127; OFF :   3;
                   Sec1 :   1; Letz :  10; SXT : 194;
                   TXT  :   2; TRK  :  39; GAP :  13),

                  (name : 'Prof 512x10, 800k';
                   BS   :   2; BLS  :   2; SPT :  80;
                   DSM  : 184; DRM  : 127; OFF :   3;
                   Sec1 :   1; Letz :  20; SXT : 194;
                   TXT  :   2; TRK  :  79; GAP :  27),

                  (name : 'Prof 1024x8, 1.2Mb';
                   BS   :   3; BLS  :   8; SPT : 128;
                   DSM  : 184; DRM  : 127; OFF :   2;
                   Sec1 :   1; Letz :   8; SXT : 195;
                   TXT  :   2; TRK  :  76; GAP :  53),

                  (name : 'Z-100';
                   BS   :   2; BLS  :   2; SPT :  64;
                   DSM  : 155; DRM  : 127; OFF :   1;
                   Sec1 :   1; Letz :   8; SXT :   1;
                   TXT  :   0; TRK  :  39; GAP :  80),

                  (name : 'User Format';
                   BS   :   3; BLS  :   4; SPT :  40;
                   DSM  : 197; DRM  : 127; OFF :   2;
                   Sec1 :   1; Letz :   5; SXT : 194;
                   TXT  :   1; TRK  :  79; GAP :  80));

type Puffer    = array [0..1023] of Byte;
     Maske     = array [0..11] of Char;
     String11  = string [18];
     CPU_Regs  = record case Boolean of
                   true  : (ax,bx,cx,dx,bp,si,di,ds,es,fl : integer);
                   false : (al,ah,bl,bh,cl,ch,dl,dh       : Byte   )
                 end;
     Disk_Para = record
                   SRT_HUT,            { Drive-Specification; ist Harware-    }
                   HLT_ND      : Byte; { abhaengig, wird nicht geaendert.     }
                   Motor_Wait  : Byte;
                   N           : 0..3; { 0 = 128, 1 = 256, 2 = 512, 3 = 1024  }
                   EOT         : Byte; { Letzter Sektor                       }
                   GPL         : Byte; { Gap-Length                           }
                   DTL         : Byte; { Data-Length                          }
                   Form_GPL    : Byte; { Gap-Length beim Formatieren          }
                   Form_Fill   : Byte; { Fuellbyte beim Formatieren           }
                   Head_Settle : Byte; { Ebenfalls Laufwerks-Konstanten       }
                   Mot_Anlauf  : Byte
                 end;


var Disk_Base        : ^Disk_Para absolute 0:$78;
    Orig_Params      : ^Disk_Para;
    User_Params      : ^Disk_Para;
    Fehler_Adresse   : record o,s : integer end absolute 0:$90;
    ActDrive         : 0..15;
    Log              : array [0..1] of 0..15;
    Disk_Format      : array [0..15] of
                         record
                           Form : 0..Fmax;
                           Drv  : 0..2
                         end;
    DiskStatus       : Byte absolute $40:$41;
    Buffer           : ^Puffer;
    DirBuffer        : Puffer;
    fcb              : array [0..33] of Char;
    Befehl,Template  : String [80];
    Fehler,Quit      : Boolean;
    EntryCount,i     : integer;

procedure getsector (Format_Nr,Block,Sekt : Byte;
                     var Track,Sector,Head : Byte);

{Umrechnungs-Routine von logischen auf phsikalische Disketten-Adressen.
 Block gibt die Groupnummer an und Sekt gibt die (phys.) Sektornummer
 innerhalb diesem Block. (In der Regel nicht 128-Byte Sektoren, sondern
 genau so grosse Sektoren, wie die Physikalische Sektorgroesse!)
 Die Standardtabellen fuer Spur- und Sektorumrechnung
 koennen bei Bedarf auch um ausgefallenere Formate vom Benutzer
 selbst erweitert werden. Dazu muss lediglich ein neuer Zweig
 in die entsprechende case-Anweisung eingefuegt werden.                      }

var used     : array [0..19] of Boolean;
    i,j,Skew : Byte;

  begin
    with Format[Format_Nr] do
      begin
        Head:=0;
        Track:=OFF+(Block*BLS*8+Sekt SHL BS) div SPT;
        Sector:=Sec1+((Block*BLS*8+Sekt SHL BS) mod SPT) shr BS;
        Case TXT of
          0 : ;
          1 : begin
                Head:=Track and 1; Track:=Track div 2
              end;
          2 : if Track>TRK then
                begin
                  Head:=1; Track:=Track-TRK
                end;
          3 : if Track>TRK then
                begin
                  Head:=1; Track:=((TRK*2)+1)-Track
                end;
          4 : if Track>TRK then
                begin
                  Head:=1; Track:=Track-(TRK+1)
                end;
          5 : begin
                Head:=Track and 1; Track:=Track div 2;
                if Head=1 then Sector:=Sector+succ(Letz-Sec1) div 2
              end
        end;
        Case SXT of
          0 : ;
          1 : if Sector>Letz then
                begin
                  Head:=1; Sector:=Sector-Letz-1+Sec1
                end;
          2 : if Sector>Sec1+(Letz-Sec1) div 2 then Head:=1;
          $82..$8F, {Double Sided}
          $C2..$CF  {Single Sided} :
              begin
                Skew:=SXT and 15;
                if Sector>Letz then
                  begin
                    Head:=1;
                    Sector:=Sector-Letz-1+Sec1
                  end;
                fillchar(Used,SizeOf(Used),false);
                j:=Sec1; Used[Sec1]:=true;
                for i:=Sec1 to pred(Sector) do
                  begin
                    j := j+Skew;
                    if j>Letz then j:=j-Letz-1+Sec1;
                    while Used[j] do
                      if j=Letz then j:=Sec1 else j:=succ(j);
                    Used[j]:=true
                  end;
                Sector:=j
              end
        end
      end
  end;

function readsector (var Buffer : Puffer;
                     Drive,Head,Track,Sector : Byte) : Boolean;

Var Regs : CPU_Regs;

  begin
    With Regs do
      begin
        fillchar(Regs,SizeOf(Regs),0);
        Disk_Base:=User_Params;
        ah:=2; {Funktion Nr. 2 : Lesen}
        al:=1; {Anzahl der Sektoren}
        dl:=Drive; dh:=Head;
        ch:=Track; cl:=Sector;
        bx:=Ofs(Buffer); es:=Seg(Buffer);
        intr($13,Regs); {Disketten-Interrupt}
        if odd(fl) then
          begin
            ah:=0; dx:=Drive; {Funktion Nr. 0 : Ruecksetzen; d.h. Recalibrate}
            intr($13,Regs);
            { delay(500); }   { A.K. Jan.90 , warten }
            ah:=2; {Lesen} al:=1;
            dl:=Drive; dh:=Head;
            ch:=Track; cl:=Sector;
            bx:=Ofs(Buffer); es:=Seg(Buffer);
            intr($13,Regs)
          end;
        Disk_Base:=Orig_Params;
        readsector:=odd(fl)
      end
  end;

function writesector (var Buffer : Puffer;
                      Drive,Head,Track,Sector : Byte) : Boolean;

var Regs : CPU_Regs;

  begin
    With Regs do
      begin
        fillchar(Regs,SizeOf(Regs),0);
        Disk_Base:=User_Params;
        ah:=3; {Funktion Nr. 3 : Schreiben}
        al:=1; {Anzahl der Sektoren}
        dl:=Drive; dh:=Head;
        ch:=Track; cl:=Sector;
        bx:=Ofs(Buffer); es:=Seg(Buffer);
        intr($13,Regs); {Disketten-Interrupt}
        if odd(fl) then
          begin
            ah:=0; dx:=Drive; {Funktion Nr. 0 : Ruecksetzen; d.h. Recalibrate}
            intr($13,Regs);
            { delay(500); }  { A.K. Jan.90 , warten }
            ah:=3; {Schreiben} al:=1;
            dl:=Drive; dh:=Head;
            ch:=Track; cl:=Sector;
            bx:=Ofs(Buffer); es:=Seg(Buffer);
            intr($13,Regs)
          end;
        Disk_Base:=Orig_Params;
        writesector:=odd(fl)
      end
  end;

function ActiveDrive : Byte;

var Regs : CPU_Regs;

  begin
    with Regs do
      begin
        fillchar(Regs,SizeOf(Regs),0);
        ah:=25;
        msdos(Regs);
        ActiveDrive:=al
      end
  end;

procedure Fehler_Behandlung;

  begin                     { leere Fehler-Behandlung.                      }
    INLINE ($2E/$8E/$1E/DATASEG);
    {DS-Register wieder herstellen}
    Fehler:=true;
    writeln;
    writeln('Diskettenfehler!');
    {Aus MSDOS-Funktion herausspringen und Fehler anzeigen}
    INLINE (                (*         .8086                               *)
    $83/$C4/$0A             (*         ADD SP,10                           *)
    /$58                    (*         POP AX                              *)
    /$5B                    (*         POP BX                              *)
    /$59                    (*         POP CX                              *)
    /$5A                    (*         POP DX                              *)
    /$5E                    (*         POP SI                              *)
    /$5F                    (*         POP DI                              *)
    /$5D                    (*         POP BP                              *)
    /$1F                    (*         POP DS                              *)
    /$07                    (*         POP ES                              *)
    /$B0/$FF                (*         MOV AL,0FFH                         *)
    /$F9                    (*         STC                                 *)
    /$CA/$02/$00            (*         RETF 2                              *)
                            (*         END                                 *))
  end;

procedure Fehlermeldung (Track,Sector,Head : Byte);

  begin
    writeln;
    writeln('Diskettenfehler bei Spur ',
            Track,' Seite ',Head,' Sektor ',Sector,':');
    case DiskStatus of
      1   : writeln('Bad Command');
      2   : writeln('Adress mark not found');
      3   : writeln('write protect');
      4   : writeln('Requested sector not found');
      8   : writeln('DMA overrun on Operation');
      16  : writeln('Bad CRC');
      32  : writeln('NEC controller has failed');
      64  : writeln('Seek operation has failed');
      128 : writeln('Attachment has failed to respond')
      else
        writeln('Fehlercode ',DiskStatus,': keine Fehlermeldung vorhanden!')
    end
  end;

procedure Sektorlesen (LDrive,Block,Sekt : Byte);

var Track,Sector,Head : Byte;

  begin
    with User_Params^,Disk_Format[LDrive],Format[Form] do
      begin
        Getsector(Form,Block,Sekt,Track,Sector,Head);
        N:=BS; EOT:=Letz;
        if Track>TRK then
          begin
            Fehler:=true;
            EXIT
          end;
        Fehler:=readsector(Buffer^,Drv,Head,Track,Sector)
      end;
    if Fehler then Fehlermeldung(Track,Sector,Head)
  end;

procedure Sektorschreiben (LDrive,Block,Sekt : Byte);

var Track,Sector,Head : Byte;

  begin
    with User_Params^,Disk_Format[LDrive],Format[Form] do
      begin
        Getsector(Form,Block,Sekt,Track,Sector,Head);
        N:=BS; EOT:=Letz;
        if Track>TRK then
          begin
            Fehler:=true;
            EXIT
          end;
        Fehler:=writesector(Buffer^,Drv,Head,Track,Sector)
      end;
    if Fehler then Fehlermeldung(Track,Sector,Head)
  end;

procedure Login (LDrive : Byte);
  begin
    with Disk_Format[LDrive] do
      if Form=0 then
        begin
         if LDrive<2 then
           if Log[LDrive]<>LDrive then
             begin
               writeln;
               writeln('Diskette ',chr(65+LDrive),': in Laufwerk ',
                       chr(65+LDrive),': einlegen!');
               readln;
               Log[LDrive]:=LDrive
             end
        end
        else
          if Log[Drv]<>LDrive then
            begin
              writeln;
              writeln('Diskette ',chr(65+LDrive),': in Laufwerk ',
                      chr(65+Drv),': einlegen!');
              readln;
              Log[Drv]:=LDrive
            end
  end;


function DirEintrag (LDrive : Byte; DirMask : Maske; First : Boolean) : Byte;

var m : integer;

  function DosDirectory : Byte;

  var Regs : CPU_Regs;

    begin
      with Regs do
        begin
          if first then
            begin
              ah:=26;
              ds:=Seg(DirBuffer); dx:=Ofs(DirBuffer);
              msdos(Regs);
              fillchar (fcb,SizeOf(fcb),#0);
              move(DirMask,fcb[0],SizeOf(Maske));
              FCB[0]:=succ(chr(LDrive))
            end;
          ah:=17+ord(not First);
          ds:=Seg(fcb[0]); dx:=Ofs(fcb[0]);
          msdos(Regs);
          DirBuffer[0]:=0;
          DosDirectory:=al
        end
    end;

  function Passt : Boolean;

  var b : Boolean;
      i : integer;

    procedure Drop7 (var x : Byte);
      begin x:=x and 127 end;

    begin
      if DirBuffer[32*m]>=16 then Passt:=false
        else
          begin
            drop7(DirBuffer[32*m+9]);
            drop7(DirBuffer[32*m+10]);
            b:=true;
            for i:=0 to 11 do
              if DirMask[i]<>'?' then
                b:=b and (ord(DirMask[i])=DirBuffer[32*m+i]);
            Passt:=b
          end
    end;

  begin
    if first then Login(LDrive);
    with Disk_Format[LDrive] do
      if Form=0 then DirEintrag:=DosDirectory
        else
          with Format[Form] do
            begin
              if First then EntryCount:=-1;
              repeat
                EntryCount:=Succ(EntryCount);
                m:=EntryCount and pred(4 shl BS);
                if (m=0) and (EntryCount<=DRM) then
                  begin
                    SektorLesen(LDrive,0,EntryCount shr (2+BS));
                    DirBuffer:=Buffer^
                  end
              until (EntryCount>DRM) or Passt or Fehler;
              if (EntryCount>DRM) or Fehler
                then DirEintrag:=255
                else DirEintrag:=m
            end
  end;

procedure PutFCB (LDrive : Byte; var FCB);

var i : integer;

  begin
    with Format[Disk_Format[LDrive].Form] do
      for i:=0 to DRM do
        begin
          if i and pred(4 shl BS)=0 then SektorLesen(LDrive,0,i shr (2+BS));
          if Fehler then EXIT;
          if Buffer^[32*(i and pred(4 shl BS))]=$E5 then
            begin
              Move(FCB,Buffer^[32*(i and pred(4 shl BS))],32);
              SektorSchreiben(LDrive,0,i shr (2+BS));
              EXIT
            end
        end;
    Fehler:=true;
    writeln;
    writeln('Directory voll!')
  end;

procedure Loesche (LDrive : Byte; DirMask : Maske);

var i          : integer;
    DosFcbName : Maske absolute DirBuffer;

  procedure SingleDosFileDel (DirMask : Maske);

  var f  : file;
      FN : String11;

    begin
      FN:=chr(65+LDrive)+':'+copy(Dirmask,2,11);
      insert('.',FN,11); assign(f,FN);
      {$I-} erase(f); {$I+}
      if ioresult<>0 then {File war nicht vorhanden}
    end;

  begin
    with Disk_Format[LDrive] do
      if Form=0 then
        begin
          Login(LDrive);
          if pos('?',DirMask)=0 then SingleDosFileDel(DirMask)
            else
              begin
                i:=DirEintrag(LDrive,DirMask,true);
                while i=0 do
                  begin
                    SingleDosFileDel(DosFcbName);
                    i:=DirEintrag(LDrive,DirMask,true)
                  end
              end
        end
        else
          with Format[Form] do
            begin
              i:=DirEintrag(LDrive,DirMask,true);
              while i<>255 do
                begin
                  Buffer^[32*i]:=$E5;
                  SektorSchreiben(LDrive,0,EntryCount shr (2+BS));
                  if Fehler then EXIT;
                  i:=DirEintrag(LDrive,DirMask,false)
                end
            end
  end;

procedure Eroeffne (LDrive : Byte; DirMask : Maske);

var f        : file;
    FN       : String11;
    DirEntry : array [0..31] of Char;

  begin
    with Disk_Format[LDrive] do
      if Form=0 then
        begin
          Login(LDrive);
          FN:=chr(65+LDrive)+':'+copy(Dirmask,2,11);
          insert('.',FN,11); assign(f,FN);
          {$I-} rewrite(f); {$I+}
          if ioresult<>0 then
            begin
              Fehler:=true; writeln;
              if pos('/',FN) or pos('\',FN) or pos('+',FN)
              or pos('>',FN) or pos('|',FN) or pos('<',FN)
              or pos('=',FN) or pos(',',FN) or pos(';',FN)<>0
              then writeln('Unerlaubter Dateiname!')
              else writeln('Directory voll!')
            end;
          close(f)
        end
        else
          with Format[Form] do
            begin
              if pos('?',DirMask)<>0 then
                begin
                  Fehler:=true;
                  EXIT
                end;
              Loesche(LDrive,DirMask);
              if Fehler then EXIT;
              Fillchar(DirEntry,SizeOf(DirEntry),#0);
              Move(DirMask,DirEntry,SizeOf(DirMask));
              PutFCB(LDrive,DirEntry)
            end
  end;

procedure ChangeDir (LDrive : Byte; D1,D2 : Maske);

var f  : file;
    FN : String11;
    i  : integer;

  begin
    with Disk_Format[LDrive] do
      if Form=0 then
        begin
          Login(LDrive);
          FN:=chr(65+LDrive)+':'+copy(D2,2,11);
          insert('.',FN,11); assign(f,FN);
          FN:=chr(65+LDrive)+':'+copy(D1,2,11);
          insert('.',FN,11);
          {$I-} rename(f,FN); {$I+}
          if ioresult<>0 then Fehler:=true
        end
        else
          with Format[Form] do
            begin
              i:=DirEintrag(LDrive,D2,true);
              if i=255 then Fehler:=true;
              while i<>255 do
                begin
                  Move(D1,Buffer^[32*i],SizeOf(Maske));
                  SektorSchreiben(LDrive,0,EntryCount shr (2+BS));
                  if Fehler then EXIT;
                  i:=DirEintrag(LDrive,D2,false)
                end
            end
  end;

procedure Blocklesen (LDrive : Byte; DirMask : Maske; var ReadBuffer;
                      Blk_Nr,Anz : integer; var gelesen : integer);

var ext,sek,i,j : integer;
    gefunden    : Boolean;
    DirEntry    : array [0..31] of Byte;
    LesePuffer  : array [0..255,0..127] of Byte absolute ReadBuffer;
    f           : file;
    FN          : String11;

  begin
    with Disk_Format[LDrive] do
      if Form=0 then
        begin
          Login(LDrive);
          FN:=chr(65+LDrive)+':'+copy(Dirmask,2,11);
          insert('.',FN,11); assign(f,FN);
          {$I-}
            reset(f);
            Seek(f,Blk_Nr);
            BlockRead(f,readbuffer,Anz,gelesen);
          {$I+}
          if ioresult<>0 then
            begin
              Fehler:=true;
              writeln;
              writeln('File nicht vorhanden!')
            end;
          close(f)
        end
        else
          with Format[Form] do
            begin
              gelesen:=0;
              if pos('?',DirMask)<>0 then
                begin
                  Fehler:=true;
                  EXIT
                end;
              ext:=Blk_Nr Div (128*BLS);
              Sek:=Blk_Nr Mod (128*BLS) SHR BS;
              repeat
                gefunden:=false;
                i:=DirEintrag(LDrive,DirMask,true);
                while (i<>255) and not gefunden do
                  if DirBuffer[32*i+12] Div BLS = ext then
                    begin
                      gefunden:=true;
                      move(DirBuffer[32*i],DirEntry,SizeOf(DirEntry))
                    end
                    else i:=DirEintrag(LDrive,DirMask,false);
                if not gefunden then
                  begin
                    if ext=0 then
                      begin
                        Fehler:=true; writeln;
                        writeln('File nicht vorhanden!')
                      end;
                    EXIT
                  end;
                i:=DirEntry[15]+128*(DirEntry[12] and pred(BLS));
                if i<128*BLS then
                  begin
                    i:= i-Sek SHL BS; if i<Anz then Anz:=i
                  end;
                if Anz>0 then
                for i:=Sek DIV (BLS*8 SHR BS) to 15 do
                  if DirEntry[i+16]<>0 then
                    for j:=Sek mod (BLS*8 SHR BS) to pred(BLS*8 SHR BS) do
                      begin
                        Sek:=0;
                        SektorLesen(LDrive,DirEntry[16+i],j);
                        if Fehler then EXIT;
                        Move(Buffer^,LesePuffer[gelesen],128 SHL BS);
                        gelesen:=gelesen+1 SHL BS;
                        Anz:=Anz-1 SHL BS;
                        if Anz<=0 then
                          begin
                            Gelesen:=Gelesen+Anz;
                            EXIT
                          end
                      end
                    else
                      begin
                        writeln;
                        writeln('FCB fehlerhaft');
                        Fehler:=true;
                        EXIT
                      end;
                Ext:=Succ(Ext); Sek:=0
              until Anz<=0
            end
  end;

procedure BlockSchreiben (LDrive : Byte; DirMask : Maske; var WriteBuffer;
                          Blk_Nr,Anz : integer);

var ext,sek,wrt,i,j,k : integer;
    gefunden          : Boolean;
    Belegung          : Set of Byte;
    DirEntry          : array [0..31] of Byte;
    SchreibPuffer     : array [0..255,0..127] of Byte absolute WriteBuffer;
    f                 : file;
    FN                : String11;

  begin
    with Disk_Format[LDrive] do
      if Form=0 then
        begin
          Login(LDrive);
          FN:=chr(65+LDrive)+':'+copy(Dirmask,2,11);
          insert('.',FN,11); assign(f,FN);
          {$I-}
            reset(f);
            Seek(f,Blk_Nr);
            Truncate(f);
            BlockWrite(f,WriteBuffer,Anz);
          {$I+}
          if ioresult<>0 then
            begin
              Fehler:=true;
              writeln;
              writeln('Diskette voll!')
            end;
          close(f)
        end
        else
          with Format[Form] do
            begin
              wrt:=0;
              if pos('?',DirMask)<>0 then
                begin
                  Fehler:=true;
                  EXIT
                end;
              Belegung:=[];
              for i:=0 to DRM div (32*BLS) do Belegung:=Belegung+[i];
              i:=DirEintrag(LDrive,'????????????',true);
              while i<>255 do
                begin
                  for j:=16 to 31 do
                    Belegung:=Belegung+[DirBuffer[32*i+j]];
                  i:=DirEintrag(LDrive,'????????????',false)
                end;
              if Fehler then EXIT;
              ext:=Blk_Nr Div (128*BLS);
              Sek:=Blk_Nr Mod (128*BLS) SHR BS;
              repeat
                gefunden:=false;
                i:=DirEintrag(LDrive,DirMask,true);
                while (i<>255) and not gefunden do
                  if DirBuffer[32*i+12] Div BLS = ext then
                    begin
                      gefunden:=true;
                      DirBuffer:=Buffer^; {DirBuffer evtl. veraendert!}
                      move(DirBuffer[32*i],DirEntry,SizeOf(DirEntry))
                    end
                    else i:=DirEintrag(LDrive,DirMask,false);
                if not gefunden then
                  begin
                    Fehler:=true;
                    writeln;
                    writeln('FCB nicht vorhanden!');
                    EXIT
                  end;
                for i:=Sek DIV (BLS*8 SHR BS) to 15 do
                  if Anz>0 then
                    begin
                      k:=DirEntry[16+i];
                      if k=0 then
                        begin
                          k:=1;
                          while (k in Belegung) and (k<=DSM) do k:=succ(k);
                          if k>DSM then
                            begin
                              Fehler:=true;
                              writeln;
                              writeln('Diskette voll!');
                              EXIT
                            end;
                          DirEntry[i+16]:=k;
                          Belegung:=Belegung+[k]
                        end;
                      for j:=Sek mod (BLS*8 SHR BS) to pred(BLS*8 SHR BS) do
                        if Anz>0 then
                          begin
                            Move(SchreibPuffer[wrt],Buffer^,128 SHL BS);
                            SektorSchreiben(LDrive,k,j);
                            if Fehler then EXIT;
                            Wrt:=Wrt+1 SHL BS;
                            Anz:=Anz-1 SHL BS
                          end;
                      Sek:=0
                    end;
                if Anz<0 Then Wrt:=Wrt+Anz;
                DirEntry[15]:=succ(pred(Blk_Nr+Wrt) and 127);
                DirEntry[12]:=ext*BLS+pred(BLS)
                              and ((Blk_Nr+Wrt-DirEntry[15]) div 128);
                Buffer^:=DirBuffer;
                  {Der oben zwischengespeicherte Directory-Block}
                Move(DirEntry,Buffer^[32*(EntryCount and pred(4 shl BS))],
                     SizeOf(DirEntry));
                SektorSchreiben(LDrive,0,EntryCount shr (2+BS));
                if Fehler then EXIT;
                Ext:=Succ(Ext);
                if (Blk_Nr+Wrt) and pred(128*BLS)=0 then
                  begin
                    DirEntry[12]:=Ext*BLS;
                    Fillchar(DirEntry[13],19,0);
                    PutFCB(LDrive,DirEntry)
                  end
              until (Anz<=0) or Fehler
            end
  end;

procedure Convert (Fname : String11; var DirMask : Maske);

const erlaubt : set of Char = [' ','%','&','-','_','#','@','$','?','`',
                               '(',')','''','"','^','!','0'..'9','A'..'Z'];
var i,j : integer;

  function OR_Sequ : Boolean;

    begin
      if j>Length(Fname)
        then OR_Sequ:=true
        else OR_Sequ:=Fname[j] in [' ','.']
    end;

  begin
    Fillchar(DirMask,SizeOf(Maske),' ');
    if pos('\',Fname)<>0 then
      begin
        i:=0; val(Fname,i,j);
        if Fname[1]='?' then DirMask[0]:='?' else DirMask[0]:=chr(i);
        Delete(Fname,1,pos('\',Fname))
      end;
    j:=1; i:=1;
    while (i<=11) and (j<=Length(Fname)) do
      if Fname[j]=' ' then i:=12
        else
          if Fname[j]='*' then
            begin
              DirMask[i]:='?'; i:=succ(i);
              if i=9 then repeat j:=succ(j) until OR_Sequ
            end
            else
              if Fname[j]='.' then
                if i=9 then j:=succ(j) else i:=succ(i)
                else
                  begin
                    DirMask[i]:=upcase(Fname[j]);
                    i:=succ(i); j:=succ(j);
                    if i=9 then while not OR_Sequ do j:=succ(j)
                  end;
    for i:=1 to 11 do
      if not (DirMask[i] in erlaubt) then DirMask[i]:='?';
    if DirMask[0]<>'?' then DirMask[0]:=chr(15 and ord(DirMask[0]));
    if DirMask[1]=' ' then fillchar(Dirmask[1],11,'?')
  end;

function LaufwerkNr (Var Fname : String11) : Byte;

var N : 0..15;

  begin
    if pos(':',Fname)<>0 then
      begin
        if Fname[1] in ['a'..'p','A'..'P']
          then N:=ord(Upcase(Fname[1]))-65
          else N:=ActDrive;
        Delete(Fname,1,pos(':',Fname))
      end
      else N:=ActDrive;
    if Disk_Format[N].Form=0 then
      while pos('\',Fname)<>0 do Delete(Fname,1,pos('\',Fname));
    LaufwerkNr:=N
  end;


procedure Formatiere;

var c              : Char;
    t,h,s,mt,mh,sn : integer;
    LDrive         : 0..15;
    ok             : Boolean;
    s1             : array [0..1] of Byte;
    Trans          : array [0..19] of Byte;
    Regs           : CPU_Regs;

  begin
    write('Laufwerk zum Formatieren? ');
    c:=chr(0);
    if Befehl<>'' then
      if Befehl[1] in ['a'..'p','A'..'P'] then c:=Upcase(Befehl[1]);
    if c=chr(0) then
      repeat
        read(kbd,c);
        if c=#13 then c:=chr(65+ActDrive) else c:=Upcase(c)
      until c in ['A'..'P'];
    writeln(c,':');
    LDrive:=ord(c)-65;
    Login(LDrive);
    with Disk_Format[LDrive] do
      if Form=0 then writeln('Fuer DOS-Disketten bitte FORMAT benuetzen!')
        else
          with Format[Form],User_Params^,Regs do
            begin
              Fillchar(Regs,SizeOf(Regs),0);
              writeln('Achtung, alle Daten auf Laufwerk ',chr(65+Drv),
                    ': werden geloescht!');
              write('OK? (J/N) ');
              repeat
                read(kbd,c);
                c:=Upcase(c)
              until c in ['J','N'];
              writeln(c);
              if c<>'J' then EXIT;
              sn:=Letz-Sec1;
              EOT:=succ(SN); N:=BS;
              Form_GPL:=GAP;
              Form_Fill:=$E5;
              if TXT=4 then mt:=34 else mt:=TRK;
              s1[0]:=Sec1;
              if (TXT<>0) or (SXT>0) and (SXT<$C0) then mh:=1 else mh:=0;
              if (SXT<>2) and (TXT<>5) then s1[1]:=Sec1
                else
                  begin
                    EOT:=EOT div 2;
                    sn:=sn div 2;
                    s1[1]:=Sec1+EOT
                  end;
              Fillchar(Trans,SizeOf(Trans),255); h:=0;
              if SXT>$80 then for h:=0 to sn do Trans[h]:=h
                else for s:=0 to sn do
                  begin
                    if s<>0 then h:=succ(8 shr BS+h);
                      repeat
                        if h>sn then h:=pred(h-sn);
                        if Trans[h]=255 then Trans[h]:=s else h:=succ(h)
                      until Trans[h]=s
                  end;
              writeln('Formatiere ',Name);
              ah:=0; dx:=Drv; {Disketten-Reset : Recalibrate}
              intr($13,Regs);
              delay(500);  { A.K. Jan.90 , warten }
              { ah:=0; dx:=Drv; } {Disketten-Reset : Recalibrate}
              { intr($13,Regs);}
              { delay(500); }  { A.K. Jan.90 , warten }
              for t:=0 to mt do
                for h:=0 to mh do
                  begin
                    write('Spur ',t,' Seite ',h,#13);
                    delay(500); { A.K. April 23, warten }
                    for s:=0 to sn do
                      begin
                        Buffer^[4*s]:=t;
                        Buffer^[4*s+1]:=h;
                        Buffer^[4*s+2]:=s1[h]+Trans[s];
                        Buffer^[4*s+3]:=BS
                      end;
                    ah:=5; {Funktion Nr. 5 : Formatieren}
                    al:=1; {Anzahl der Sektoren muss definiert sein!}
                    dl:=Drv; dh:=h; ch:=t;
                    es:=Seg(Buffer^); bx:=Ofs(Buffer^);
                    Disk_Base:=User_Params;
                    intr($13,Regs);
                    Disk_Base:=Orig_Params;
                    if odd(fl) then
                      begin
                        Writeln;
                        Writeln('Formatier-Fehler!');
                        EXIT
                      end
                  end;
              writeln;
              writeln('Format ok.')
            end
  end;

procedure WriteDir (D : String11);

var i,j,k   : integer;
    LDrive  : 0..15;
    DirMask : Maske;
    Dir     : array [Byte] of Maske;

  procedure FreeSpace (LW : Byte);

  var Space,i,j : integer;
      Regs      : CPU_Regs;

    begin
      with Disk_Format[LW] do
        if Form=0 then
          with Regs do
            begin
              Fillchar(Regs,SizeOf(Regs),0);
              Login(LW);
              ah:=54; {MSDOS : freien Diskettenplatz ermitteln}
              dl:=succ(LW);
              msdos(Regs);
              if ax=-1
                then Space:=0
                else Space:=round(1.0*bx*ax*cx/1024)
            end
          else
            with Format[Form] do
              begin
                Space:= DSM - DRM div (32*BLS);
                i:=DirEintrag(LW,'????????????',true);
                while i<>255 do
                  begin
                    for j:=16 to 31 do
                      if DirBuffer[32*i+j]<>0 then Space:=pred(Space);
                    i:=DirEintrag(LW,'????????????',false)
                  end;
                if Fehler then EXIT;
                Space:=Space*BLS
              end;
      writeln(chr(65+LW),': ',Space,' K frei.')
    end;

  begin
    LDrive:=LaufwerkNr(d);
    Convert(d,DirMask);
    j:=-1; i:=DirEintrag(LDrive,Dirmask,true);
    while i<>255 do
      begin
        j:=succ(j);
        Move(DirBuffer[32*i],Dir[j],SizeOf(Maske));
        for k:=0 to pred(j) do
          if Dir[k]=Dir[j] then i:=255;
        if i=255 then j:=pred(j);
        i:=DirEintrag(LDrive,Dirmask,false)
      end;
    if Fehler then EXIT;
    write('Directory von ',chr(65+LDrive),':');
    for k:=0 to j do
      begin
        if k mod 5=0 then writeln;
        if Dir[k,0]=#0
          then write(' : ')
          else write(ord(Dir[k,0]):2,'\');
        write(copy(Dir[k],2,8),' ',copy(Dir[k],10,3))
      end;
    writeln;
    if j=-1 then writeln('No file!');
    FreeSpace(LDrive)
  end;

procedure TypeFile (FN : String11);

var DirMask     : Maske;
    c           : Char;
    i,j,k       : integer;
    LDrive      : 0..15;
    BlockPuffer : array [0..2047] of Char;

  begin
    LDrive:=LaufwerkNr(FN);
    Convert(FN,DirMask);
    if pos('?',DirMask)<>0 then EXIT;
    i:=0;
    repeat
      Blocklesen(LDrive,DirMask,BlockPuffer,i,16,j);
      if Fehler then
        begin
          writeln;
          writeln('Fehler!');
          EXIT
        end;
      for k:=0 to pred(128*j) do
        begin
          if BlockPuffer[k]=^Z then
            begin
              writeln;
              EXIT
            end;
          if KeyPressed then
            begin
              Read(KBD,c);
              if c=^S then read(KBD,c);
              if c=^C then
                begin
                  writeln('^C');
                  EXIT
                end
            end;
          if BlockPuffer[k]=^I
            then write('':succ(pred(WhereX) and 7 xor 7))
            else write(BlockPuffer[k])
        end;
      i:=i+j
    until j<>16;
    writeln
  end;

procedure CopyFile (FN1,FN2 : String11);

var D1,D2  : Maske;
    i,j,k  : integer;
    L1,L2  : 0..15;
    c      : Char;
    Dir    : array [Byte] of Maske;

  procedure SingleFileCopy (D1,D2 : Maske);

  var i,k         : integer;
      BlockPuffer : array [0..maxint] of Byte;

    begin
      i:=0;
      repeat
        BlockLesen(L2,D2,BlockPuffer,i,256,k);
        if Fehler then
          begin
            writeln('Lese-Fehler!');
            EXIT
          end;
        if i=0 then Eroeffne(L1,D1);
        if not Fehler and (k<>0) then BlockSchreiben(L1,D1,BlockPuffer,i,k);
        if Fehler then
          begin
            Fehler:=false; Loesche(L1,D1); Fehler:=true;
            writeln('Schreib-Fehler!');
            EXIT
          end;
        i:=i+k
      until k<>256
    end;

  begin
    L1:=LaufwerkNr(FN1); L2:=LaufwerkNr(FN2);
    if FN1='' then FN1:=FN2;
    Convert(FN1,D1); Convert(FN2,D2);
    if (pos('?',D1)+pos('?',D2)=0) and ((D1<>D2) or (L1<>L2))
      then SingleFileCopy(D1,D2)
      else
        if ((copy(D1,2,11)=copy(D2,2,11)) or (copy(D1,2,11)='???????????'))
           and ((L1<>L2) or (D1[0]<>'?') and (D2[0]<>'?') and (D1[0]<>D2[0]))
          then
            begin
              j:=-1; i:=DirEintrag(L2,D2,true);
              if i=255 then writeln('File nicht gefunden!');
              while i<>255 do
                begin
                  j:=succ(j);
                  move(DirBuffer[32*i],Dir[j],SizeOf(Maske));
                  for k:=0 to pred(j) do
                    if Dir[k]=Dir[j] then i:=255;
                  if i=255 then j:=pred(j);
                  i:=DirEintrag(L2,D2,false)
                end;
              if Fehler then EXIT;
              for k:=0 to j do
                begin
                  if Dir[k,0]<>#0
                    then write(ord(Dir[k,0]):2,'\');
                  writeln(copy(Dir[k],2,8),' ',copy(Dir[k],10,3));
                  D2:=Dir[k];
                  if D1[0]<>'?' then D2[0]:=D1[0];
                  SingleFileCopy(D2,Dir[k]);
                  if Fehler then EXIT;
                  while KeyPressed do
                    begin
                      read(KBD,c);
                      if c=^C then
                        begin writeln('Abgebrochen!'); EXIT end
                    end
                end
            end
          else writeln('Syntax-Fehler!')
  end;

procedure RenameFile (FN1,FN2 : String11);

var D1,D2 : Maske;
    LW    : 0..15;
    i     : Byte;

  begin
    LW:=LaufwerkNr(FN1);
    if LW<>LaufwerkNr(FN2) then
       begin
         writeln('Verschiedene Laufwerke!');
         EXIT
       end;
    convert(FN1,D1); convert(FN2,D2);
    if (pos('?',D1)+pos('?',D2)<>0) or (D1=D2) then
      begin writeln('Syntax-Fehler!'); EXIT end;
    i:=DirEintrag(LW,D1,true);
    if i<>255 then
      begin
        writeln('Zieldatei existiert bereits!');
        EXIT
      end;
    ChangeDir(LW,D1,D2);
    if Fehler then writeln('Fehler!')
  end;

procedure DeleteFile (Name : String11);

var DirMaske : Maske;
    LW       : 0..15;
    c        : char;

  begin
    LW:=LaufwerkNr(Name); Convert(Name,DirMaske);
    if copy(DirMaske,2,11)='???????????' then
      begin
        write('Alle Files loeschen? (J/N) ');
        repeat
          read(kbd,c);
          c:=Upcase(c)
        until c in ['J','N'];
        writeln(c);
        if c<>'J' then EXIT
      end;
    Loesche(LW,DirMaske)
  end;

procedure SetDiskPar;

var c      : Char;
    i      : integer;
    LDrive : 0..15;

  procedure SetUserFormat;

    var Antwort : Char;
        i       : Integer;
        mform   : file of Byte;
        b       : Byte;
        ok      : Boolean;

    begin
      Write('Soll das User Format modifiziert werden? ');
      repeat
        read(kbd,Antwort); Antwort:=Upcase(Antwort)
      until Antwort in ['J','N',#13]; Writeln(Antwort);
      if Antwort='J' then with Format[Fmax] do
        begin
          Write('Sektorgroesse',128 shl BS:17,' ');
          i:=0; readln(i);
          case i of 128 : BS:=0; 256 : BS:=1; 512 : BS:=2; 1024 : BS:=3 end;
          Write('Blockgroesse',BLS:18,' ');
          i:=0; readln(i); if i in [1,2,4] then BLS:=i;
          Write('CP/M-Sektoren pro Spur',SPT:8,' ');
          i:=0; readln(i); if i>0 then SPT:=i;
          Write('Anzahl der Bloecke',succ(DSM):12,' ');
          i:=0; readln(i); if i>1 then DSM:=pred(i);
          Write('Directory Eintraege',succ(DRM):11,' ');
          i:=0; readln(i); if i>1 then DRM:=pred(i);
          Write('Reservierte Spuren',Off:12,' ');
          i:=-1; readln(i); if (i>=0) and (i<=8) then Off:=i;
          Write('Erster Sektor',Sec1:17,' ');
          i:=-1; readln(i); if i shr 1=0 then Sec1:=i;
          Write('Letzter Sektor',Letz:16,' ');
          i:=0; readln(i); if i<>0 then Letz:=i;
          Write('Sektoruebersetzung',SXT:12,' ');
          i:=-1; readln(i); if i<>-1 then SXT:=i;
          Write('Spuruebersetzung',TXT:14,' ');
          i:=-1; readln(i); if i<>-1 then TXT:=i;
          Write('Spuren pro Seite',TRK:14,' ');
          i:=-1; readln(i); if i<>-1 then TRK:=i;
          Write('GAP bei Format',GAP:16,' ');
          i:=-1; readln(i); if i<>-1 then GAP:=i;

          Writeln; Writeln('Das neue User Format lautet jetzt:'); Writeln;
          Writeln('Sektorgroesse',128 shl BS:17);
          Writeln('Blockgroesse',BLS:18);
          Writeln('CP/M-Sektoren pro Spur',SPT:8);
          Writeln('Anzahl der Bloecke',succ(DSM):12);
          Writeln('Directory Eintraege',succ(DRM):11);
          Writeln('Reservierte Spuren',Off:12);
          Writeln('Erster Sektor',Sec1:17);
          Writeln('Letzter Sektor',Letz:16);
          Writeln('Sektoruebersetzung',SXT:12);
          Writeln('Spuruebersetzung',TXT:14);
          Writeln('Spuren pro Seite',TRK:14);
          Writeln('GAP bei Format',GAP:16);
          Writeln; Write('Soll das gespeichert werden? ');
          repeat
            read(kbd,Antwort);
            Antwort:=Upcase(Antwort)
         until Antwort in ['J','N']; Writeln(Antwort);
         if Antwort='J' then
            begin
              ok:=True;
              assign(mform,'MFORM.COM');
              {$I-} reset(mform); {$I+}
              if ioresult=0 then
              if LongFileSize(mform)>ofs(TXT) then
                begin
                  Seek(mform,ofs(TXT)-255);
                  for i:=1 to 256 do
                    begin
                      read(mform,b); if b<>mem[cseg:ofs(TXT)+i] then ok:=False
                    end;
                  if ok then
                    begin
                      Seek(mform,ofs(BS)-256);
                      for i:=ofs(BS) to ofs(TXT) do write(mform,mem[cseg:i])
                    end
                end else ok:=False else ok:=False;
              close(mform);
              if ok then Writeln('User Format ist nun modifiziert.')
                    else Writeln('MFORM.COM nicht da oder falsche Version.')
            end
        end
    end;

  begin
    write('Laufwerk? '); c:=chr(0);
    if Befehl<>'' then
      if Befehl[1] in ['a'..'p','A'..'P'] then c:=Upcase(Befehl[1]);
    if c=chr(0) then
      repeat
        read(kbd,c);
        if c=#13 then c:=chr(65+ActDrive) else c:=Upcase(c)
      until c in ['A'..'P'];
    writeln(c,':');
    LDrive:=ord(c)-65;
    write('DOS =  0':25);
    for i:=1 to Fmax do
      begin
        if i mod 3=0 then writeln;
        write(Format[i].Name:20,' = ',i:2)
      end;
    with Disk_Format[LDrive] do
      begin
        writeln;
        writeln;
        write('Ihre Wahl: ');
        i:=Form; readln(i); if (i>=0) and (i<=Fmax) then Form:=i;
        if Form=Fmax then SetUserFormat;
        if c in ['A','B'] then Drv:=LDrive;
        if Form=0 then Drv:=2;
        if (Form<>0) and not (c in ['A','B']) then
          begin
            write('Phys. Laufwerk? ');
            repeat
              read(kbd,c);
              if c=#13 then c:=chr(65+Drv) else c:=upcase(c)
            until c in ['A','B'];
            writeln(c,':');
            Drv:=ord(c)-65;
            Log[Drv]:=LDrive
          end;
        if LDrive<2 then Log[LDrive]:=LDrive;
        if Form<>0
          then writeln(chr(65+LDrive),':= ',Format[Form].Name)
          else writeln(chr(65+LDrive),':= DOS')
      end
  end;

procedure ReadBefehl;

var c : Char;
    n : integer;

  begin
    Befehl:='';
    repeat
      read(kbd,c);
      if c=^[ then if KeyPressed then
        begin
          read(kbd,c);
          case c of
            'K', {CRSR Links} 'S' {DEL} : c:=^S; 'M', {CRSR Rechts}
            ';' {F1}  : c:=^D; '=' {F3} : c:=^R else c:=^@
          end
        end;
      case c of
        ' '..'~' :
             begin
               Befehl:=Befehl+c; write(c)
             end;
        #127,^H,^S :
             if Befehl<>'' then
               begin
                 Delete(Befehl,Length(Befehl),1);
                 Write(^H' '^H)
               end;
        ^D : if Length(Befehl)<Length(Template) then
               begin
                 Write(Template[succ(Length(Befehl))]);
                 Befehl:=Befehl+Template[succ(Length(Befehl))]
               end;
        ^[,^R :
             begin
               for n:=1 to Length(Befehl) do write(^H' '^H);
               Befehl:=Template; write(Template)
             end
        end
    until c=#13;
    writeln;
    Template:=Befehl
  end;

procedure Skip;

var tmp : string [3];
    i   : 1..3;

  begin
    tmp:=copy(Befehl,1,3);
    for i:=1 to length(tmp) do tmp[i]:=Upcase(tmp[i]);
    if (tmp='COP') or (tmp='DIR') or (tmp='ERA') or (tmp='FOR') or
       (tmp='LOG') or (tmp='REN') or (tmp='SET') or (tmp='TYP')
      then
        begin
          Delete(Befehl,1,3);
          if pos(' ',Befehl)>0
            then Delete(Befehl,1,pos(' ',Befehl))
            else Befehl:=''
        end
      else Delete(Befehl,1,1);
    while pos(' ',Befehl)=1 do Delete(Befehl,1,1)
  end;

begin
  CLRSCR;
  Writeln(Version);
  Fehler_Adresse.o:=Ofs(Fehler_Behandlung);
  Fehler_Adresse.s:=Cseg;
  DataSeg:=Dseg;
  Quit:=false; Template:='';
  ActDrive:=ActiveDrive;
  Orig_Params:=Disk_Base;
  new(User_Params); User_Params^:=Orig_Params^;
  repeat
    new(Buffer) {Buffer^ muss in einem physikalischen 64K-Segment sein!}
  until ( (Ofs(Buffer^)+16*Seg(Buffer^)) >= 0 )
        or ( (Ofs(Buffer^)+16*Seg(Buffer^)+SizeOf(Buffer^)) < 0 );
  Log[0]:=0; Log[1]:=1;
  for i:=0 to 15 do
    with Disk_Format[i] do begin Form:=0; Drv:=2 end;
  repeat
    Fehler:=false;
    repeat
      write('->');
      ReadBefehl
    until length(Befehl)>0;
    case upcase(Befehl[1]) of
      'C' : begin
              Skip; i:= pos('=',Befehl);
              if i<>0
                then CopyFile(copy(Befehl,1,i-1),
                              copy(Befehl,i+1,length(Befehl)-i))
                else
                  begin
                    i:=pos(',',Befehl);
                    if i=0 then
                      begin
                        i:=pos(' ',Befehl);
                        if i=0 then
                          begin
                            Befehl:=Befehl+' ';
                            i:=length(Befehl)
                          end
                          else while pos('  ',Befehl)=i do Delete(Befehl,i,1)
                      end;
                    CopyFile(copy(Befehl,i+1,length(Befehl)-i),
                             copy(Befehl,1,i-1))
                  end
            end;
      'D' : begin Skip; WriteDir(Befehl) end;
      'E' : begin Skip; DeleteFile(Befehl) end;
      'F' : begin Skip; Formatiere end;
      'L' : begin
              Skip;
              if Befehl=''
                then writeln('Aktives Laufwerk ',chr(65+ActDrive),':')
                else if Befehl[1] in ['a'..'p','A'..'P']
                       then
                         begin
                           ActDrive:=ord(Upcase(Befehl[1]))-65;
                           if Length(Befehl)>=3 then if Befehl[2]=':' then
                             if Disk_Format[ActDrive].Form=0 then
                               begin
                                 {$I-} ChDir(Befehl); {$I+}
                                 if ioresult<>0 then
                                   writeln('Subdirectory nicht gefunden!')
                               end
                         end
            end;
      'R' : begin
              Skip; i:= pos('=',Befehl);
              if i<>0
                then RenameFile(copy(Befehl,1,i-1),
                                copy(Befehl,i+1,length(Befehl)-i))
                else
                  begin
                    i:=pos(',',Befehl);
                    if i=0 then
                      begin
                        i:=pos(' ',Befehl);
                        if i<>0 then
                          while pos('  ',Befehl)=i do Delete(Befehl,i,1)
                      end;
                    if i<>0
                      then RenameFile(copy(Befehl,i+1,length(Befehl)-i),
                                      copy(Befehl,1,i-1))
                      else writeln('Syntax-Fehler!')
                  end
            end;
      'S' : begin Skip; SetDiskPar end;
      'T' : begin Skip; TypeFile(Befehl) end;
      '?' : begin
       writeln('C dest=src - Kopiere File(s)  :  R neu=alt  - RENAME File      ');
       writeln('D Maske    - DIR              :  S x        - Setze Format     ');
       writeln('E file     - ERASE File(s)    :  T src      - TYPE File        ');
       writeln('F x        - Formatiere Disk  :  Q          - Quit             ');
       writeln('L x        - Laufwerk waehlen :  ?          - HILFE!           ')
            end;
      'Q' : Quit:=true
      else writeln(' ? fuer Hilfe!')
    end
  until Quit
end.

